// {$WARNINGS OFF}
// {$WARN SYMBOL_PLATFORM OFF}
// {$WARN UNIT_PLATFORM OFF}
// =============================================================================
// GDI+ ֌WTv
// ڂ摜쐬p̊֐Ƃ̊֐gp}XN摜̍쐬
//
// -----------------------------------------------------------------------------
//
// ygpz
//
// TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
// (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
// ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
// ȂC{TCg̃vOR[hgpƂɂĐCȂ
// QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
// -----------------------------------------------------------------------------
//
// yz
//
// 2017N0801 `
//
// -----------------------------------------------------------------------------
//
// ymFz
//
// Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
// Presented by Mr.XRAY
// http://mrxray.on.coocan.jp/
// =============================================================================
unit plBlurGDIplus;

interface

uses
  Windows, SysUtils, Graphics, GDIPAPI, GDIPOBJ, GDIPUTIL;

  function GaussianBlur(AGPSrcBmp: TGPBitmap; ARadius: Integer;
    ARepeat: integer = 1): TGPBitmap;
  function CreateGaussianBlurShadow(ABitmap: TGPBitmap; ARadius: Integer;
    AOpacity: Double = 1.0; AColor: TColor = clNone): TGPBitmap;
  function BoxBlur(ABitmap: TGPBitmap; ARadius: Integer): TGPBitmap;
  function CreateBoxBlurShadow(ABitmap: TGPBitmap; ARadius: Integer;
    AOpacity: Double = 1.0; AColor: TColor = clNone): TGPBitmap;

implementation

uses
  Math;

//=============================================================================
//  KEVAڂ(KEXڂEGaussian Blur)֐
//
//  ߂lTGPBitmap͂̊֐Ő
//  Ej͌ďoŎs
//
//  AGPSrcBmp : ΏۂTGPBitmap(̊֐ł͕ύX͂Ȃ)
//  ARadius   : قvZ̔a
//  ARepeat   : JԂ(2ȏɂƕɂȂ)
//=============================================================================
function GaussianBlur(AGPSrcBmp: TGPBitmap; ARadius: Integer;
  ARepeat: integer = 1): TGPBitmap;

  //---------------------------------------------------------------------------
  //  wʒuPRGBQuad̒l擾
  //---------------------------------------------------------------------------
  function GetPRGBQuad(ABmpData: TBitmapData; APosY, APosX: Integer) : PRGBQuad;
  begin
    Result := ABmpData.Scan0;
    inc(PByte(Result), APosY * ABmpData.stride + APosX);
  end;
  //---------------------------------------------------------------------------

var
  LYRepeatCnt  : Integer;
  LXRepeatCnt  : Integer;
  LDiameter    : Integer;
  LImgWidth    : Integer;
  LImgHeight   : Integer;
  LPosX        : Integer;
  LPosY        : Integer;
  LPixel1      : Integer;
  LPixel2      : Integer;
  LCalcX       : Integer;
  LCalcY       : Integer;
  LBmpData     : TBitmapData;
  LpARGB       : PRGBQuad;
  LAlpha       : array of Integer;
  LRed         : array of Integer;
  LGreen       : array of Integer;
  LBlue        : array of Integer;
  LScanStart   : Integer;
  LBytesShift  : Integer;
begin
  Result := TGPBitmap(AGPSrcBmp.Clone);
  if ARadius <= 0 then exit;

  LDiameter   := (ARadius * 2) + 1;
  LBytesShift := SizeOf(TRGBQuad);

  LImgWidth  := Result.GetWidth- 1;
  LImgHeight := Result.GetHeight - 1;

  //TGPBitmap̃rbg}bvf[^擾
  if Result.LockBits(MakeRect(0, 0, LImgWidth, LImgHeight),
                        ImageLockModeWrite or ImageLockModeRead,
                        PixelFormat32bppARGB, LBmpData) <> Ok then exit;

  //Z͈͂(xax2+1)Ɋg
  SetLength(LAlpha, LImgWidth + 1 + (ARadius * 2));
  SetLength(LRed,   LImgWidth + 1 + (ARadius * 2));
  SetLength(LGreen, LImgWidth + 1 + (ARadius * 2));
  SetLength(LBlue,  LImgWidth + 1 + (ARadius * 2));

  for LPosY := 0 to LImgHeight do begin
    for LYRepeatCnt := 1 to ARepeat do begin
      LXRepeatCnt := -ARadius;
      while LXRepeatCnt <= LImgWidth + ARadius do begin
        LCalcX := LXRepeatCnt;
        if LCalcX < 0 then begin
          LCalcX := 0;
        end else
        if LCalcX >= LImgWidth then begin
          LCalcX := LImgWidth;
        end;

        LpARGB  := GetPRGBQuad(LBmpData, LPosY, LCalcX * LBytesShift);
        LPixel1 := LXRepeatCnt + ARadius;
        LPixel2 := LXRepeatCnt + ARadius - 1;

        LAlpha[LPixel1] := LpARGB^.rgbReserved + LAlpha[LPixel2];
        LRed  [LPixel1] := LpARGB^.rgbRed      + LRed  [LPixel2];
        LGreen[LPixel1] := LpARGB^.rgbGreen    + LGreen[LPixel2];
        LBlue [LPixel1] := LpARGB^.rgbBlue     + LBlue [LPixel2];

        inc(LXRepeatCnt);
      end;

      for LPosX := 0 to LImgWidth do begin
        LpARGB  := GetPRGBQuad(LBmpData, LPosY, LPosX * LBytesShift);
        LCalcX  := LPosX + ARadius;
        LPixel1 := LCalcX + ARadius;
        LPixel2 := LCalcX - 1 - ARadius;

        LpARGB^.rgbReserved := ((LAlpha[LPixel1] - LAlpha[LPixel2]) div LDiameter);
        LpARGB^.rgbRed      := ((LRed  [LPixel1] - LRed  [LPixel2]) div LDiameter);
        LpARGB^.rgbGreen    := ((LGreen[LPixel1] - LGreen[LPixel2]) div LDiameter);
        LpARGB^.rgbBlue     := ((LBlue [LPixel1] - LBlue [LPixel2]) div LDiameter);
      end;
    end;
  end;


  //Z͈͂(xax2+1)Ɋg
  SetLength(LAlpha, LImgHeight + 1 + (ARadius * 2));
  SetLength(LRed,   LImgHeight + 1 + (ARadius * 2));
  SetLength(LGreen, LImgHeight + 1 + (ARadius * 2));
  SetLength(LBlue,  LImgHeight + 1 + (ARadius * 2));

  for LPosX := 0 to LImgWidth do begin
    for LYRepeatCnt := 1 to ARepeat do begin
      LScanStart  := 0;
      LXRepeatCnt := -ARadius;
      while LXRepeatCnt <= LImgHeight + ARadius do begin
        if (LXRepeatCnt > 0) and (LXRepeatCnt < LImgHeight) then begin
          inc(LScanStart);
        end;

        LpARGB  := GetPRGBQuad(LBmpData, LScanStart, LPosX * LBytesShift);
        LPixel1 := LXRepeatCnt + ARadius;
        LPixel2 := LXRepeatCnt + ARadius - 1;

        LAlpha[LPixel1] := LpARGB.rgbReserved + LAlpha[LPixel2];
        LRed  [LPixel1] := LpARGB.rgbRed      + LRed  [LPixel2];
        LGreen[LPixel1] := LpARGB.rgbGreen    + LGreen[LPixel2];
        LBlue [LPixel1] := LpARGB.rgbBlue     + LBlue [LPixel2];

        inc(LXRepeatCnt);
      end;

      for LPosY := 0 to LImgHeight do begin
        LpARGB  := GetPRGBQuad(LBmpData, LPosY, LPosX * LBytesShift);
        LCalcY  := LPosY + ARadius;
        LPixel1 := LCalcY + ARadius;
        LPixel2 := LCalcY - 1 - ARadius;

        LpARGB.rgbReserved := ((LAlpha[LPixel1] - LAlpha[LPixel2]) div LDiameter);
        LpARGB.rgbRed      := ((LRed  [LPixel1] - LRed  [LPixel2]) div LDiameter);
        LpARGB.rgbGreen    := ((LGreen[LPixel1] - LGreen[LPixel2]) div LDiameter);
        LpARGB.rgbBlue     := ((LBlue [LPixel1] - LBlue [LPixel2]) div LDiameter);
      end;
    end;
  end;
  Result.UnlockBits(LBmpData);

  SetLength(LAlpha, 0);
  SetLength(LRed, 0);
  SetLength(LGreen, 0);
  SetLength(LBlue, 0);
end;

//=============================================================================
//  KEXڂgpĂق摜̃}XN摜쐬֐
//
//  ߂lTGPBitmap͂̊֐Ő
//  Ej͌ďoŎs
//
//  ABitmap  : ΏۂTGPBitmap(̊֐ł͕ύX͂Ȃ)
//  ARadius  : قvZ̔a
//  AOpacity : sx(0.0 - 1.0)D0.0͊Sȓ
//             1.0ɂƒPF̉摜ƂȂ蔼̃sNZ͐Ȃ
//  AColor   : }XN摜̐F
//
//  sxƐF̈ȗƎӕ܂߂Ăڂ摜ƂȂ
//=============================================================================
function CreateGaussianBlurShadow(ABitmap: TGPBitmap; ARadius: Integer;
  AOpacity: Double = 1.0; AColor: TColor = clNone): TGPBitmap;
var
  LShadow       : TGPBitmap;
  LClone        : TGPBitmap;
  LGraphics     : TGPGraphics;
  LShadowData   : TBitmapData;
  LColor        : TGPColor;
  LShadowWidth  : Integer;
  LShadowHeight : Integer;
  LScanLine     : PByte;
  LpRGBQuad     : PRGBQuad;
  LDataStride   : Integer;
  LXPos         : integer;
  LYPos         : Integer;
  LAlphaValue   : Byte;
begin
  ARadius := Max(ARadius, 0);
  LClone := TGPBitmap.Create(ABitmap.GetWidth + (4 * Cardinal(ARadius)),
                             ABitmap.GetHeight + (4 * Cardinal(ARadius)),
                             PixelFormat32bppARGB);
  LGraphics := TGPGraphics.Create(LClone);
  //ڂ摜͂ڂ̈TCYX2sNZE`
  //ȂƋ`̏[ƍ[̂ق؂Ă܂
  //ڂ摜̎ۂ̕`ʒu͌ďoōs
  LGraphics.DrawImage(ABitmap,
                      MakeRect(2 * ARadius, 2 * ARadius,
                      ABitmap.GetWidth,
                      ABitmap.GetHeight),
                      0,
                      0,
                      ABitmap.GetWidth,
                      ABitmap.GetHeight,
                      UnitPixel);

  try
    LShadow := GaussianBlur(LClone, ARadius, 1);
    if (AColor <> clNone) or (AOpacity <> 1.0) then begin
      LShadowWidth  := LShadow.GetWidth;
      LShadowHeight := LShadow.GetHeight;
      LShadow.LockBits(MakeRect(0, 0, LShadowWidth, LShadowHeight),
                       ImageLockModeRead or ImageLockModeWrite,
                       PixelFormat32bppARGB,
                       LShadowData);

      LColor := ColorRefToARGB(AColor);

      LScanLine   := LShadowData.Scan0;
      LDataStride := LShadowData.Stride;

      for LYPos := 0 to LShadowHeight - 1 do begin
        LpRGBQuad := PRGBQuad(LScanLine);
        for LXPos := 0 to LShadowWidth - 1 do begin
          if LpRGBQuad^.rgbReserved <> 0 then begin
            LAlphaValue := Round(LpRGBQuad^.rgbReserved * AOpacity);
            LpRGBQuad^.rgbReserved := LAlphaValue;
            LpRGBQuad^.rgbRed   := GetRed(LColor);
            LpRGBQuad^.rgbGreen := GetGreen(LColor);
            LpRGBQuad^.rgbBlue  := GetBlue(LColor);
          end;
          Inc(LpRGBQuad);
        end;
        Inc(LScanLine, LDataStride);
      end;
    end;
    Result := TGPBitmap(LShadow.Clone);
  finally
    LShadow.UnlockBits(LShadowData);
    FreeAndNil(LClone);
    FreeAndNil(LShadow);
    FreeAndNil(LGraphics);
  end;
end;

//-----------------------------------------------------------------------------
//  Box Blurڂ֐
//  ȉ̃EFuy[WɌfڂ̊֐GDI+1.0pɕύXR[h
//  (fڂ̃R[hDelphi 2009 GDI+ Library p)
//  https://stackoverflow.com/questions/7364026/algorithm-for-fast-drop-shadow-in-gdi
//
//  ߂lTGPBitmap͂̊֐Ő
//  Cj͌ďoōs
//
//  usesMathKv
//-----------------------------------------------------------------------------
procedure BoxBlur_Routine(const AData1, AData2: TBitmapData; AWidth, AHeight,
  ARadius: Integer);
const
  CHANNELS = 4;
var
  LScan1      : PByte;
  LScan2      : PByte;
  LSum        : array [0..CHANNELS-1] of Integer;
  LFirstValue : array [0..CHANNELS-1] of Integer;
  LLastValue  : array [0..CHANNELS-1] of Integer;
  LRadius2    : Integer;
  LStride     : Integer;
  LStart      : Integer;
  LChannel    : Integer;
  LLeft       : Integer;
  LRight      : Integer;
  LBottom     : Integer;
  LTop        : Integer;
  LRow        : Integer;
  LColumn     : Integer;
begin
  LScan1   := AData1.Scan0;
  LScan2   := AData2.Scan0;
  LRadius2 := (2 * ARadius) + 1;
  LStride  := AData1.Stride;

  for LRow := 0 to AHeight - 1 do begin
    LStart := LRow * LStride;
    LLeft  := LStart;
    LRight := LStart + ARadius * CHANNELS;
    for LChannel := 0 to CHANNELS - 1 do begin
      LFirstValue[LChannel] := LScan1[LStart + LChannel];
      LLastValue[LChannel] := LScan1[LStart + ((AWidth
                            - 1) * CHANNELS) + LChannel];
      LSum[LChannel] := (ARadius + 1) * LFirstValue[LChannel];
    end;

    for LColumn := 0 to ARadius - 1 do begin
      for LChannel := 0 to CHANNELS - 1 do begin
        LSum[LChannel] := LSum[LChannel] + LScan1[LStart
                        + (LColumn * CHANNELS) + LChannel];
      end;
    end;

    for LColumn := 0 to ARadius do begin
      for LChannel := 0 to CHANNELS - 1 do begin
        LSum[LChannel] := LSum[LChannel] + LScan1[LRight
                        + LChannel] - LFirstValue[LChannel];
        LScan2[LStart + LChannel] := Byte(LSum[LChannel] div LRadius2);
      end;
      Inc(LRight, CHANNELS);
      Inc(LStart, CHANNELS);
    end;

    for LColumn := ARadius + 1 to AWidth - ARadius - 1 do begin
      for LChannel := 0 to CHANNELS - 1 do begin
        LSum[LChannel] := LSum[LChannel] + LScan1[LRight + LChannel]
                        - LScan1[LLeft + LChannel];
        LScan2[LStart + LChannel] := Byte(LSum[LChannel] div LRadius2);
      end;
      Inc(LLeft, CHANNELS);
      Inc(LRight, CHANNELS);
      Inc(LStart, CHANNELS);
    end;

    for LColumn := AWidth-ARadius to AWidth-1 do begin
      for LChannel := 0 to CHANNELS - 1 do begin
        LSum[LChannel] := LSum[LChannel] + LLastValue[LChannel]
                        - LScan1[LLeft + LChannel];
        LScan2[LStart + LChannel] := Byte(LSum[LChannel] div LRadius2);
      end;
      Inc(LLeft, CHANNELS);
      Inc(LStart, CHANNELS);
    end;
  end;

  LStride := AData2.Stride;
  for LColumn := 0 to AWidth - 1 do begin
    LStart := LColumn * CHANNELS;
    LTop := LStart;
    LBottom := LStart + (ARadius * LStride);
    for LChannel := 0 to CHANNELS - 1 do begin
      LFirstValue[LChannel] := LScan2[LStart + LChannel];
      LLastValue[LChannel] := LScan2[LStart + ((AHeight - 1) * LStride) + LChannel];
      LSum[LChannel] := (ARadius + 1) * LFirstValue[LChannel];
    end;

    for LRow := 0 to ARadius-1 do begin
      for LChannel := 0 to CHANNELS - 1 do begin
        LSum[LChannel] := LSum[LChannel] + LScan2[LStart
                        + (LRow * LStride) + LChannel];
      end;
    end;

    for LRow := 0 to ARadius do begin
      for LChannel := 0 to CHANNELS - 1 do begin
        LSum[LChannel] := LSum[LChannel] + LScan2[LBottom + LChannel]
                        - LFirstValue[LChannel];
        LScan1[LStart + LChannel] := Byte(LSum[LChannel] div LRadius2);
      end;
      Inc(LBottom, LStride);
      Inc(LStart, LStride);
    end;

    for LRow := ARadius + 1 to AHeight - ARadius - 1 do begin
      for LChannel := 0 to CHANNELS - 1 do begin
        LSum[LChannel] := LSum[LChannel] + LScan2[LBottom
                        + LChannel] - LScan2[LTop + LChannel];
        LScan1[LStart + LChannel] := Byte(LSum[LChannel] div LRadius2);
      end;
      Inc(LTop, LStride);
      Inc(LBottom, LStride);
      Inc(LStart, LStride);
    end;

    for LRow := AHeight - ARadius to AHeight-1 do begin
      for LChannel := 0 to CHANNELS - 1 do begin
        LSum[LChannel] := LSum[LChannel] + LLastValue[LChannel]
                        - LScan2[LTop + LChannel];
        LScan1[LStart + LChannel] := Byte(LSum[LChannel] div LRadius2);
      end;
      Inc(LTop, LStride);
      Inc(LStart, LStride);
    end;
  end;
end;

//=============================================================================
//  {bNXڂ(Box Blur)gpĂق摜̃}XN摜쐬֐
//
//  ߂lTGPBitmap͂̊֐Ő
//  Ej͌ďoŎs
//
//  ABitmap  : ΏۂTGPBitmap(̊֐ł͕ύX͂Ȃ)
//  ARadius  : قvZ̔a
//  AOpacity : sx(0.0 - 1.0)D0.0͊Sȓ
//             1.0ɂƒPF̉摜ƂȂ蔼̃sNZ͐Ȃ
//  AColor   : }XN摜̐F
//
//  sxƐF̈ȗƎӕ܂߂Ăڂ摜ƂȂ
//
//  usesMathKv
//=============================================================================
function CreateBoxBlurShadow(ABitmap: TGPBitmap; ARadius: Integer;
  AOpacity: Double = 1.0; AColor: TColor = clNone): TGPBitmap;
var
  LShadow       : TGPBitmap;
  LClone        : TGPBitmap;
  LGraphics     : TGPGraphics;
  LShadowData   : TBitmapData;
  LCloneData    : TBitmapData;
  LColor        : TGPColor;
  LShadowWidth  : Integer;
  LShadowHeight : Integer;
  LCloneWidth   : Integer;
  LCloneHeight  : Integer;
  LScanLine     : PByte;
  LpRGBQuad     : PRGBQuad;
  LDataStride   : Integer;
  LXPos         : integer;
  LYPos         : Integer;
  LAlphaValue   : Byte;
begin
  ARadius := Max(ARadius, 0);
  LShadow := TGPBitmap.Create(ABitmap.GetWidth + (4 * Cardinal(ARadius)),
                              ABitmap.GetHeight + (4 * Cardinal(ARadius)),
                              PixelFormat32bppARGB);
  LGraphics := TGPGraphics.Create(LShadow);
  //ڂ摜͂ڂ̈TCYX2sNZE`
  //ȂƋ`̏[ƍ[̂ق؂Ă܂
  //ڂ摜̎ۂ̕`ʒu͌ďoōs
  LGraphics.DrawImage(ABitmap, MakeRect(2 * ARadius, 2 * ARadius,
                                        ABitmap.GetWidth,
                                        ABitmap.GetHeight),
                                        0,
                                        0,
                                        ABitmap.GetWidth,
                                        ABitmap.GetHeight,
                                        UnitPixel);
  LClone := TGPBitmap(LShadow.Clone);
  LShadowWidth := LShadow.GetWidth;
  LShadowHeight := LShadow.GetHeight;
  LShadow.LockBits(MakeRect(0, 0, LShadowWidth, LShadowHeight),
                   ImageLockModeRead or ImageLockModeWrite,
                   PixelFormat32bppARGB,
                   LShadowData);

  LCloneWidth  := LClone.GetWidth;
  LCloneHeight := LClone.GetHeight;
  LClone.LockBits(MakeRect(0, 0, LCloneWidth, LCloneHeight),
                  ImageLockModeRead or ImageLockModeWrite,
                  PixelFormat32bppARGB,
                  LCloneData);

  try
    BoxBlur_Routine(LShadowData, LCloneData, LShadowWidth, LShadowHeight, ARadius - 1);
    BoxBlur_Routine(LShadowData, LCloneData, LShadowWidth, LShadowHeight, ARadius - 1);
    BoxBlur_Routine(LShadowData, LCloneData, LShadowWidth, LShadowHeight, ARadius);

    if (AColor <> clNone) or (AOpacity <> 1.0) then begin
      LColor := ColorRefToARGB(AColor);

      LScanLine   := LShadowData.Scan0;
      LDataStride := LShadowData.Stride;

      for LYPos := 0 to LShadowHeight - 1 do begin
        LpRGBQuad := PRGBQuad(LScanLine);
        for LXPos := 0 to LShadowWidth - 1 do begin
          if LpRGBQuad^.rgbReserved <> 0 then begin
            LAlphaValue := Round(LpRGBQuad^.rgbReserved * AOpacity);
            LpRGBQuad^.rgbReserved := LAlphaValue;
            LpRGBQuad^.rgbRed   := GetRed(LColor);
            LpRGBQuad^.rgbGreen := GetGreen(LColor);
            LpRGBQuad^.rgbBlue  := GetBlue(LColor);
          end;
          Inc(LpRGBQuad);
        end;
        Inc(LScanLine, LDataStride);
      end;
    end;
    Result := TGPBitmap(LShadow.Clone);
  finally
    LShadow.UnlockBits(LShadowData);
    LClone.UnlockBits(LCloneData);
    FreeAndNil(LClone);
    FreeAndNil(LShadow);
    FreeAndNil(LGraphics);
  end;
end;

//=============================================================================
//  Box Blurڂ֐gpĉ摜̋`̈̂ڂ摜쐬֐
//
//  ߂lTGPBitmap͂̊֐Ő
//  Cj͌ďoōs
//
//  ABitmap  : ΏۂTGPBitmap(̊֐ł͕ύX͂Ȃ)
//  ARadius  : قvZ̔a
//
//  usesMathKv
//=============================================================================
function BoxBlur(ABitmap: TGPBitmap; ARadius: Integer): TGPBitmap;
var
  LShadow       : TGPBitmap;
  LClone        : TGPBitmap;
  LGraphics     : TGPGraphics;
  LShadowData   : TBitmapData;
  LCloneData    : TBitmapData;
  LShadowWidth  : Integer;
  LShadowHeight : Integer;
  LCloneWidth   : Integer;
  LCloneHeight  : Integer;
begin
  ARadius := Max(ARadius, 0);
  LShadow := TGPBitmap.Create(ABitmap.GetWidth,
                              ABitmap.GetHeight,
                              PixelFormat32bppARGB);

  LGraphics := TGPGraphics.Create(LShadow);
  LGraphics.DrawImage(ABitmap, MakeRect(0, 0,
                                        ABitmap.GetWidth,
                                        ABitmap.GetHeight),
                                        0,
                                        0,
                                        ABitmap.GetWidth,
                                        ABitmap.GetHeight,
                                        UnitPixel);
  LClone := TGPBitmap(LShadow.Clone);
  LShadowWidth := LShadow.GetWidth;
  LShadowHeight := LShadow.GetHeight;
  LShadow.LockBits(MakeRect(0, 0, LShadowWidth, LShadowHeight),
                   ImageLockModeRead or ImageLockModeWrite,
                   PixelFormat32bppARGB,
                   LShadowData);

  LCloneWidth  := LClone.GetWidth;
  LCloneHeight := LClone.GetHeight;
  LClone.LockBits(MakeRect(0, 0, LCloneWidth, LCloneHeight),
                  ImageLockModeRead or ImageLockModeWrite,
                  PixelFormat32bppARGB,
                  LCloneData);

  try
    BoxBlur_Routine(LShadowData, LCloneData, LShadowWidth, LShadowHeight, ARadius - 1);
    BoxBlur_Routine(LShadowData, LCloneData, LShadowWidth, LShadowHeight, ARadius - 1);
    BoxBlur_Routine(LShadowData, LCloneData, LShadowWidth, LShadowHeight, ARadius);

    Result := TGPBitmap(LShadow.Clone);
  finally
    LShadow.UnlockBits(LShadowData);
    LClone.UnlockBits(LCloneData);
    FreeAndNil(LClone);
    FreeAndNil(LShadow);
    FreeAndNil(LGraphics);
  end;
end;

end.

end.

